<template>
  <q-page class="flex-center">
    <q-table
      :rows-per-page-options="[15, 25, 50]"
      :data="data"
      :columns="columns"
      separator="cell"
      :pagination.sync="pagination"
      @request="onRequest"
      row-key="id"
    >
      <template slot="top" slot-scope="props">
        <q-btn
          push
          rounded
          color="primary"
          icon="add"
          @click="add()"
          v-show="permissions.includes('add_company')"
          >Add Company </q-btn
        >&nbsp;&nbsp;
        <q-btn
          push
          rounded
          color="primary"
          icon="add"
          @click="clone()"
          v-show="permissions.includes('add_company')"
        >
          Clone Company
        </q-btn>
        <div class="col" />
      </template>
      <q-tr slot="body" slot-scope="props" :props="props">
        <q-td
          key="No"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
          @click.native="detail(props.row.id)"
          class="cursor-pointer"
          >{{ props.row.No }}
        </q-td>
        <q-td
          key="company_name"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          @click.native="detail(props.row.id)"
          class="cursor-pointer"
          >{{ props.row.company_name }}
        </q-td>
        <q-td
          key="fullname"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          @click.native="detail(props.row.id)"
          class="cursor-pointer"
          >{{ props.row.fullname }}
        </q-td>
        <q-td
          key="username"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          @click.native="detail(props.row.id)"
          class="cursor-pointer"
          >{{ props.row.username }}
        </q-td>
        <q-td
          key="phone"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          @click.native="detail(props.row.id)"
          class="cursor-pointer"
          >{{ props.row.phone }}
        </q-td>
        <q-td
          key="credit"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          @click.native="detail(props.row.id)"
          class="cursor-pointer"
          >{{ props.row.credit | toUSD }}
        </q-td>
        <q-td
          key="operation_code"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          @click.native="detail(props.row.id)"
          class="cursor-pointer"
          >{{ props.row.operation_code }}
        </q-td>
        <q-td
          key="status"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <q-toggle
            v-model="props.row.status"
            :false-value="0"
            :true-value="1"
            v-show="permissions.includes('change_company')"
            @input="ChangeStatus(props.row)"
          ></q-toggle>
          <div v-show="!permissions.includes('change_company')">
            {{ props.row.status }}
          </div>
        </q-td>
        <q-td
          key="action"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <div class="row items-center justify-between no-wrap">
            <q-btn
              size="sm"
              round
              rounded
              color="secondary"
              icon="edit"
              @click="load(props.row)"
              class="q-mr-xs"
              v-show="permissions.includes('change_company')"
            />
            <!-- <q-btn size="sm" round rounded color="negative" icon="delete" @click="remove(props.row)" class="q-mr-xs" v-show="permissions.includes('delete_company')"/> -->
          </div>
        </q-td>
      </q-tr>

      <template v-slot:top-row>
        <q-tr>
          <q-td></q-td>
          <q-td colspan="6">
            <q-input
              dense
              debounce="300"
              outlined
              v-model="filter.name"
              label="Filter Company Name"
              @input="getdata"
            ></q-input>
          </q-td>
          <q-td colspan="6">
            <q-select
              dense
              debounce="300"
              outlined
              label="Select Status"
              v-model="filter.status"
              :options="options"
              option-value="value"
              option-label="label"
              option-disable="inactive"
              emit-value
              map-options
              @input="getdata"
            />
          </q-td>
        </q-tr>
      </template>
    </q-table>
    <!-- add -->
    <q-dialog
      full-width
      full-height
      v-model="modal_add"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" @click="cancel()" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form"
            ref="form"
            :rules="rules"
            label-width="140px"
            class="demo-dynamic"
          >
            <el-form-item label="Company Name" prop="company_name">
              <el-input
                v-model="form.company_name"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Owner Name" prop="fullname">
              <el-input v-model="form.fullname" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Credit2" prop="credit">
              <currency-input v-model="form.credit" currency="THB" />
            </el-form-item>
            <el-form-item label="Operation Code" prop="operation_code">
              <el-input
                v-model="form.operation_code"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Secrete Key" prop="secrete_key">
              <el-input
                v-model="form.secrete_key"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Report Url" prop="report_url">
              <el-input v-model="form.report_url" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Api Url" prop="api_url">
              <el-input v-model="form.api_url" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Username" prop="username">
              <el-input v-model="form.username" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Password" prop="password">
              <el-input
                v-model="form.password"
                type="password"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Confrim" prop="confrim">
              <el-input
                type="password"
                v-model="form.confrim"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <!-- <el-form-item label="Phone" prop="phone">
              <el-input v-model="form.phone" autocomplete="off"></el-input>
            </el-form-item>             -->
          </el-form>
        </q-card-section>
        <q-card-section>
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="provider"
            :columns="game_columns"
            separator="cell"
            row-key="id"
            virtual-scroll
            :pagination.sync="pagination_provider"
          >
            <q-tr slot="header" slot-scope="props" :props="props">
              <q-th key="status_" :props="props">
                <q-checkbox
                  keep-color
                  v-model="checkall"
                  color="green"
                  @input="onSelection"
                />
              </q-th>
              <q-th key="name" :props="props">Name</q-th>
              <q-th key="percent" :props="props">
                <div class="row">
                  <div class="col-12">Percent</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1"
                      v-model="percent_"
                      controls-position="right"
                      :min="0"
                      :max="percent"
                      @change="syncpercent"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
              <q-th key="commission" :props="props">
                <div class="row">
                  <div class="col-12">Commission</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1"
                      v-model="commission_"
                      controls-position="right"
                      :min="0"
                      :max="10"
                      @change="synccommison"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
            </q-tr>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="status_"
                :props="props"
                :style="{ width: '50px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.status_"
                  color="green"
                  @input="rowSelect"
                />
              </q-td>
              <q-td
                key="name"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
                >{{ props.row.name }}
              </q-td>
              <q-td
                key="percent"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1"
                    v-model="props.row.percent_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.percent"
                  ></el-input-number>
                </template>
              </q-td>
              <q-td
                key="commission"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1"
                    v-model="props.row.commission_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.commission"
                  ></el-input-number>
                </template>
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="insert()">Submit</q-btn>
          <q-btn push rounded color="primary" @click="cancel()" v-close-popup
            >Cancel</q-btn
          >
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- update -->
    <q-dialog
      full-width
      full-height
      v-model="modal_edit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup @click="cancel()">
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_edit"
            ref="form_edit"
            :rules="rules_edit"
            label-width="140px"
            class="demo-dynamic"
          >
            <el-form-item label="Company Name" prop="company_name">
              <el-input
                v-model="form_edit.company_name"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Owner Name" prop="fullname">
              <el-input
                v-model="form_edit.fullname"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Username" prop="username">
              <el-input
                v-model="form_edit.username"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Credit" prop="credit">
              <currency-input v-model="form_edit.credit" currency="THB" />
            </el-form-item>
            <el-form-item label="Operation Code" prop="operation_code">
              <el-input
                v-model="form_edit.operation_code"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Secrete Key" prop="secrete_key">
              <el-input
                v-model="form_edit.secrete_key"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Report Url" prop="report_url">
              <el-input
                v-model="form_edit.report_url"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Api Url" prop="api_url">
              <el-input
                v-model="form_edit.api_url"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <!-- <el-form-item label="Phone" prop="phone">
              <el-input v-model="form_edit.phone" autocomplete="off"></el-input>
            </el-form-item>             -->
          </el-form>
        </q-card-section>
        <q-card-section>
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="provider"
            :columns="game_columns"
            separator="cell"
            row-key="id"
            virtual-scroll
            :pagination.sync="pagination_provider"
          >
            <q-tr slot="header" slot-scope="props" :props="props">
              <q-th key="status_" :props="props">
                <q-checkbox
                  keep-color
                  v-model="checkall"
                  color="green"
                  @input="onSelection"
                />
              </q-th>
              <q-th key="name" :props="props">Name</q-th>
              <q-th key="percent" :props="props">
                <div class="row">
                  <div class="col-12">Percent</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1"
                      v-model="percent_"
                      controls-position="right"
                      :min="0"
                      :max="percent"
                      @change="syncpercent"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
              <q-th key="commission" :props="props">
                <div class="row">
                  <div class="col-12">Commission</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1"
                      v-model="commission_"
                      controls-position="right"
                      :min="0"
                      :max="10"
                      @change="synccommison"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
            </q-tr>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="status_"
                :props="props"
                :style="{ width: '50px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.status_"
                  color="green"
                  @input="rowSelect"
                />
              </q-td>
              <q-td
                key="name"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
                >{{ props.row.name }}
              </q-td>
              <q-td
                key="percent"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1"
                    v-model="props.row.percent_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.percent"
                  ></el-input-number>
                </template>
              </q-td>
              <q-td
                key="commission"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1"
                    v-model="props.row.commission_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.commission"
                  ></el-input-number>
                </template>
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="Update()">Submit</q-btn>
          <q-btn push rounded color="primary" @click="cancel()" v-close-popup
            >Cancel</q-btn
          >
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- clone -->

    <q-dialog
      full-width
      full-height
      v-model="modal_clone"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" @click="cancel()" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form label-width="140px" class="demo-dynamic">
            <el-form-item label="Select Company" prop="company_name">
              <q-select
                filled
                v-model="cid"
                :options="company_options"
                @input="getcompany"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
          </el-form>
        </q-card-section>
        <div v-show="section_clone">
          <q-card-section>
            <el-form
              :model="form_clone"
              ref="form_clone"
              :rules="rules"
              label-width="140px"
              class="demo-dynamic"
            >
              <el-form-item label="Company Name" prop="company_name">
                <el-input
                  v-model="form_clone.company_name"
                  autocomplete="off"
                ></el-input>
              </el-form-item>
              <el-form-item label="Owner Name" prop="fullname">
                <el-input
                  v-model="form_clone.fullname"
                  autocomplete="off"
                ></el-input>
              </el-form-item>
              <el-form-item label="Credit" prop="credit">
                <currency-input v-model="form_clone.credit" currency="THB" />
              </el-form-item>
              <el-form-item label="Operation Code" prop="operation_code">
                <el-input
                  v-model="form_clone.operation_code"
                  autocomplete="off"
                ></el-input>
              </el-form-item>
              <el-form-item label="Secrete Key" prop="secrete_key">
                <el-input
                  v-model="form_clone.secrete_key"
                  autocomplete="off"
                ></el-input>
              </el-form-item>
              <el-form-item label="Report Url" prop="report_url">
                <el-input
                  v-model="form_clone.report_url"
                  autocomplete="off"
                ></el-input>
              </el-form-item>
              <el-form-item label="Api Url" prop="api_url">
                <el-input
                  v-model="form_clone.api_url"
                  autocomplete="off"
                ></el-input>
              </el-form-item>
              <el-form-item label="Username" prop="username">
                <el-input
                  v-model="form_clone.username"
                  autocomplete="off"
                ></el-input>
              </el-form-item>
              <el-form-item label="Password" prop="password">
                <el-input
                  v-model="form_clone.password"
                  type="password"
                  autocomplete="off"
                ></el-input>
              </el-form-item>
              <el-form-item label="Confrim" prop="confrim">
                <el-input
                  type="password"
                  v-model="form_clone.confrim"
                  autocomplete="off"
                ></el-input>
              </el-form-item>
              <!-- <el-form-item label="Phone" prop="phone">
                <el-input v-model="form_clone.phone" autocomplete="off"></el-input>
              </el-form-item>             -->
            </el-form>
          </q-card-section>
          <q-card-actions align="right" class="bg-primary text-white">
            <q-btn push rounded color="primary" @click="clone()">Submit</q-btn>
            <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
          </q-card-actions>
        </div>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
export default {
  name: "Company",
  data() {
    var validatePass = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("Please input the password"));
      } else {
        if (this.$refs.form) {
          if (this.form.confrim !== "") {
            this.$refs.form.validateField("confrim");
          }
        } else if (this.$refs.form_clone) {
          if (this.form_clone.confrim !== "") {
            this.$refs.form_clone.validateField("confrim");
          }
        }

        callback();
      }
    };
    var validatePass2 = (rule, value, callback) => {
      if (this.$refs.form) {
        if (value === "") {
          callback(new Error("Please input the password again"));
        } else if (value !== this.form.password) {
          callback(new Error("Two inputs don't match!"));
        } else {
          callback();
        }
      } else if (this.$refs.form_clone) {
        if (value === "") {
          callback(new Error("Please input the password again"));
        } else if (value !== this.form_clone.password) {
          callback(new Error("Two inputs don't match!"));
        } else {
          callback();
        }
      }
    };
    return {
      data: [],
      search: "",
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          align: "left",
          stortable: true
        },
        {
          name: "company_name",
          label: "Company Name",
          field: "company_name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "fullname",
          label: "Owner Name",
          field: "fullname",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "username",
          label: "Username",
          field: "username",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "phone",
          label: "Phone",
          field: "phone",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "credit",
          label: "Credit",
          field: "credit",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "operation_code",
          label: "Operation Code",
          field: "operation_code",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      game_columns: [
        {
          name: "status_",
          label: "Status",
          field: "status_",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "percent",
          label: "Percent",
          field: "percent",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "commission",
          label: "Commission",
          field: "commission",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      filter: {},
      separator: "horizontal",
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 10,
        rowsNumber: 10
      },
      modal_edit: false,
      modal_add: false,
      form: {
        company_name: "",
        fullname: "",
        username: "",
        password: "",
        phone: "",
        operation_code: "",
        secrete_key: "",
        report_url: "",
        api_url: "",
        credit: null,
        status: 1,
        detail: []
      },
      form_edit: {},
      rules: {
        company_name: [
          {
            required: true,
            message: "Please input company name",
            trigger: "blur"
          }
        ],
        fullname: [
          {
            required: true,
            message: "Please input Owner name",
            trigger: "blur"
          }
        ],
        username: [
          { required: true, message: "Please input username", trigger: "blur" }
        ],
        phone: [
          { required: false, message: "Please input phone", trigger: "blur" }
        ],
        operation_code: [
          {
            required: true,
            message: "Please input operation code",
            trigger: "blur"
          }
        ],
        secrete_key: [
          {
            required: true,
            message: "Please input secrete key",
            trigger: "blur"
          }
        ],
        report_url: [
          {
            required: true,
            message: "Please input report url",
            trigger: "blur"
          },
          {
            type: "url",
            message: "Please input correct domain address",
            trigger: ["blur", "change"]
          }
        ],
        api_url: [
          { required: true, message: "Please input api url", trigger: "blur" },
          {
            type: "url",
            message: "Please input correct domain address",
            trigger: ["blur", "change"]
          }
        ],
        credit: [
          { required: true, message: "Please input Credit", trigger: "blur" }
        ],
        password: [
          { required: true, validator: validatePass, trigger: "blur" }
        ],
        confrim: [{ required: true, validator: validatePass2, trigger: "blur" }]
      },

      rules_edit: {
        company_name: [
          {
            required: true,
            message: "Please input company name",
            trigger: "blur"
          }
        ],
        fullname: [
          {
            required: true,
            message: "Please input Owner name",
            trigger: "blur"
          }
        ],
        phone: [
          { required: false, message: "Please input phone", trigger: "blur" }
        ],
        credit: [
          { required: true, message: "Please input Credit", trigger: "blur" }
        ],
        operation_code: [
          {
            required: true,
            message: "Please input operation code",
            trigger: "blur"
          }
        ],
        secrete_key: [
          {
            required: true,
            message: "Please input secrete key",
            trigger: "blur"
          }
        ],
        report_url: [
          {
            required: true,
            message: "Please input report url",
            trigger: "blur"
          },
          {
            type: "url",
            message: "Please input correct url domain ",
            trigger: ["blur", "change"]
          }
        ],
        api_url: [
          { required: true, message: "Please input api url", trigger: "blur" },
          {
            type: "url",
            message: "Please input correct url domain",
            trigger: ["blur", "change"]
          }
        ]
      },
      options: [
        { value: 3, label: "Please Select" },
        { value: 1, label: "Enable" },
        { value: 0, label: "Disable" }
      ],
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      provider: [],
      group: [],
      form_game: [],
      permissions:
        this.$q.sessionStorage.getItem("permissions")["company"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["company"]
          : [],
      modal_clone: false,
      form_clone: {
        company_name: "",
        fullname: "",
        username: "",
        password: "",
        phone: "",
        operation_code: "",
        secrete_key: "",
        report_url: "",
        api_url: "",
        credit: null,
        status: 1,
        detail: []
      },
      cid: "",
      company_options: [],
      section_clone: false,
      pagination_provider: {
        rowsPerPage: 0
      },
      percent: null,
      commission: null,
      percent_: null,
      commission_: null,
      checkall: false
    };
  },

  async created() {
    await this.getdata();
    await this.get_provider();
  },

  methods: {
    async onRequest(props) {
      try {
        this.loading = true;
        const { page, rowsPerPage, sortBy, descending } = props.pagination;
        this.filter.page_limit = rowsPerPage;
        this.filter.page = page;
        if (this.filter.name == "") {
          delete this.filter.name;
        }

        if (this.filter.status == 3) {
          delete this.filter.status;
        }
        let result = await this.$services.company.read(this.filter);
        this.pagination.rowsNumber = result.total;
        const fetchCount =
          rowsPerPage === 0 ? this.pagination.rowsNumber : rowsPerPage;
        const startRow = (page - 1) * rowsPerPage;
        this.data = result.results;
        this.$services.updateindex(this.data);
        this.pagination.page = page;
        this.pagination.rowsPerPage = rowsPerPage;
        this.pagination.sortBy = sortBy;
        this.pagination.descending = descending;
        this.loading = false;
        this.set_company_option();
      } catch (e) {
        this.$services.error(e.response, this.$router);
      }
    },

    async getdata() {
      this.onRequest({
        pagination: this.pagination
      });
    },

    async get_provider() {
      try {
        this.provider = await this.$services.provider.read({ status: 1 });
        this.percent = Math.max.apply(
          Math,
          this.provider.map(function(obj) {
            return obj.percent;
          })
        );
        this.commission = Math.max.apply(
          Math,
          this.provider.map(function(obj) {
            return obj.commission;
          })
        );
      } catch (e) {
        this.$services.error(e.response, this.$router);
      }
    },

    set_company_option() {
      this.company_options = [];
      this.data.forEach(row => {
        this.company_options.push({ value: row.id, label: row.company_name });
      });
    },

    async add() {
      this.modal_add = true;
      this.form = {
        company_name: "",
        fullname: "",
        username: "",
        password: "",
        phone: "",
        operation_code: "",
        secrete_key: "",
        report_url: "",
        api_url: "",
        credit: null,
        status: 1,
        detail: []
      };
    },

    async insert() {
      let ctx = this;
      this.provider.forEach(row => {
        if (row.status_ != undefined && row.status_ == 1) {
          this.form.detail.push({
            provider_id: row.id,
            percent: row.percent_,
            commission: row.commission_
          });
        }
      });
      this.$refs.form.validate(valid => {
        if (valid) {
          this.$services.company
            .add(this.form)
            .then(function(data) {
              ctx.getdata();
              ctx.cancel();
              ctx.modal_add = false;
              ctx.$services.success("Save Company Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    },

    async load(data) {
      var result = [];
      var game = [];
      this.form_edit = data;
      this.modal_edit = true;
      let subscribe = await this.$services.subscribe.read(data.member);
      this.provider.forEach(row => {
        let result = subscribe.filter(obj => {
          return obj.provider === row.id;
        });
        if (result.length > 0) {
          row["percent_"] = result[0].percent;
          row["commission_"] = result[0].commission;
          row["id_"] = result[0].id;
          row["status_"] = true;
        }
      });
      this.rowSelect();
    },

    async Update() {
      let ctx = this;
      this.form_edit.detail = [];
      this.provider.forEach(row => {
        if (row.id_ != undefined && row.status_ == 1) {
          this.form_edit.detail.push({
            id: row.id_,
            provider_id: row.id,
            percent: row.percent_,
            commission: row.commission_
          });
        } else if (row.status_ == 1) {
          this.form_edit.detail.push({
            provider_id: row.id,
            percent: row.percent_,
            commission: row.commission_
          });
        }
      });
      this.$refs.form_edit.validate(valid => {
        if (valid) {
          this.$services.company
            .update(this.form_edit, this.form_edit.id)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_edit = false;
              ctx.cancel();
              ctx.$services.success("Update Company Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    },

    async remove(row) {
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want to Company name ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          ctx.$services.company
            .remove(row.id)
            .then(function(e) {
              ctx.getdata();
              ctx.$services.success("Delete Company " + row.name + " Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          // console.log('>>>> Cancel')
        });
    },

    ChangeStatus(row) {
      const prev = row.status == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Company ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          let data = { status: row.status };
          this.$services.company
            .status(data, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Company Success");
            })
            .catch(function(e) {
              row.status = prev;
              ctx.$services.error(e.response, ctx.router);
            });
        })
        .onCancel(() => {
          row.status = prev;
          // console.log('>>>> Cancel')
        });
    },

    detail(id) {
      if (this.$route.name != "companydetail") {
        this.$router.push({ name: "companydetail", params: { id: id } });
      }
    },

    async cancel() {
      await this.get_provider();
      this.form_edit = {};
      this.form = {
        name: "",
        operation_code: "",
        secrete_key: "",
        report_url: "",
        api_url: "",
        credit: null,
        status: "",
        detail: []
      };
    },

    async clone() {
      let ctx = this;
      if (this.$refs.form_clone) {
        this.$refs.form_clone.validate(valid => {
          if (valid) {
            // console.log('clone:', this.form_clone)
            this.$services.company
              .add(this.form_clone)
              .then(function(data) {
                ctx.getdata();
                ctx.modal_clone = false;
                ctx.section_clone = false;
                ctx.$services.success("Clone Company Success");
              })
              .catch(function(e) {
                ctx.$services.error(e.response, ctx.$router);
              });
          }
        });
      } else {
        this.modal_clone = true;
      }
    },

    getcompany(id) {
      let data = this.data.filter(row => {
        return row.id == id;
      })[0];
      this.form_clone = {
        company_name: "",
        fullname: "",
        username: "",
        password: "",
        phone: "",
        operation_code: "",
        secrete_key: "",
        report_url: "",
        api_url: "",
        credit: null,
        status: 1,
        credit: data.credit,
        detail: []
      };
      this.section_clone = true;
      data.detail.forEach(row => {
        this.form_clone.detail.push({
          provider_id: row.provider,
          percent: row.percent,
          commission: row.commission
        });
      });
    },

    rowSelect(value) {
      if (
        this.provider.filter(row => {
          return row.status_ == 1;
        }).length == this.provider.length
      ) {
        this.checkall = true;
      } else {
        this.checkall = false;
      }
    },

    onSelection(value) {
      this.provider.forEach(row => {
        row.status_ = value;
      });
    },

    syncpercent(value) {
      this.provider.forEach(row => {
        row.percent_ = row.percent >= value ? value : row.percent;
      });
    },

    synccommison(value) {
      this.provider.forEach(row => {
        row.commission_ = row.commission > value ? value : row.commission;
      });
    }
  },

  filters: {
    toUSD(value) {
      if (value) {
        return `${value.toLocaleString()}`;
      }
    }
  }
};
</script>

<style lang="stylus"></style>
<style type="text/css">
img {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 100%;
}

.image {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 50%;
}
</style>

<style lang="sass">
.my-sticky-header-table
  /* height or max-height is important */
  height: 500px

  .q-table__top,
  .q-table__bottom,
  thead tr:first-child th
    /* bg color is important for th; just specify one */
    background-color: #c1f4cd

  thead tr th
    position: sticky
    z-index: 1

  thead tr:first-child th
    top: 0

  /* this is when the loading indicator appears */


  &.q-table--loading thead tr:last-child th
    /* height of all previous header rows */
    top: 48px
</style>
